CREATE DATABASE qmail;
GRANT ALL ON qmail.* TO 'greylist'@'localhost' IDENTIFIED BY 'topSecret';
FLUSH PRIVILEGES;
USE qmail;
CREATE TABLE relaytofrom
(
    id BIGINT(20) NOT NULL auto_increment,
    relay_ip VARCHAR(16) default NULL,
    mail_from VARCHAR(255) default NULL,
    rcpt_to VARCHAR(255) default NULL,
    block_expires DATETIME NOT NULL default '0000-00-00 00:00:00',
    record_expires DATETIME NOT NULL default '0000-00-00 00:00:00',
    blocked_count BIGINT(20) NOT NULL default '0',
    passed_count BIGINT(20) NOT NULL default '0',
    aborted_count BIGINT(20) NOT NULL default '0',
    origin_type ENUM('MANUAL', 'AUTO') NOT NULL DEFAULT 'MANUAL',
    create_time DATETIME NOT NULL default '0000-00-00 00:00:00',
    last_update TIMESTAMP(14) NOT NULL,
    PRIMARY KEY (id),
    KEY relay_ip (relay_ip),
    KEY mail_from (mail_from(20)),
    KEY rcpt_to (rcpt_to(20)) 
) TYPE=MyISAM;
